Index: main/trunk/gli/classes/dictionary.properties
===================================================================
--- main/trunk/gli/classes/dictionary.properties	(revision 29031)
+++ main/trunk/gli/classes/dictionary.properties	(revision 29034)
@@ -941,24 +941,24 @@
 #
 #***** FormatConversionDialog *****
-FormatConversionDialog.Title:Convert Greenstone2 format statements to Greenstone3
+FormatConversionDialog.Accept_All:Accept All
+FormatConversionDialog.Accept_All_Tooltip:Closes this dialog, accepting the default Greenstone3 format statements that have been automatically produced for the current and any subsequent Greenstone2 format statements.
+FormatConversionDialog.Cancel_Or_Accept_All:One or more Greenstone3 format statements contains invalid XML.\nEither press Cancel to correct the XML.\nOr press OK to store the Greenstone3 format statements as-is, albeit inactive.\nYou can later use the Format tab to revisit the format statements if you want to update their syntax.
+FormatConversionDialog.Cancel_Or_Continue_Next:Either press Cancel to go back and re-edit the XML.\nOr press OK to store the current XML as-is, albeit inactive, and continue on to the next statement.\nYou can later use the Format tab to revisit this format statement if you want to update its syntax.
+FormatConversionDialog.Cancel_Tooltip:Cancels out of opening the collection and closes this dialog, discarding any changes made in the dialog.
+FormatConversionDialog.Error_GS3_Format:Error in Greenstone3 format statement.
+FormatConversionDialog.GS2_Text_Tooltip:Greenstone2 format statement.
+FormatConversionDialog.GS3_Text_Tooltip:Greenstone3 format statement, must be XML to be active in Greenstone.
+FormatConversionDialog.Invalid_XML:Invalid XML.
+FormatConversionDialog.Invalid_XML_Warning_Title:Cancel or Continue?
+FormatConversionDialog.Next:Next
+FormatConversionDialog.Next_Tooltip:Inspect the next Greenstone3 format statement that has been automatically converted from a Greenstone2 format statement.
 FormatConversionDialog.Reconvert:Reconvert
 FormatConversionDialog.Reconvert_Tooltip:Converts the text that is currently in the Greenstone2 format text area into a Greenstone3 format statement.
+FormatConversionDialog.Tidy_Done:Tidy done.
+FormatConversionDialog.Tidy_Failed:Tidy failed.
+FormatConversionDialog.Title:Convert Greenstone2 format statements to Greenstone3
 FormatConversionDialog.XHTML_Tidy:XHTML Tidy
 FormatConversionDialog.XHTML_Tidy_Tooltip:Will run HTML Tidy over the Greenstone3 format statement to try to fix up obvious XHTML errors.
-FormatConversionDialog.Next:Next
-FormatConversionDialog.Next_Tooltip:Inspect the next Greenstone3 format statement that has been automatically converted from a Greenstone2 format statement.
-FormatConversionDialog.Accept_All:Accept All
-FormatConversionDialog.Accept_All_Tooltip:Closes this dialog, accepting the default Greenstone3 format statements that have been automatically produced for the current and any subsequent Greenstone2 format statements.
-FormatConversionDialog.Cancel_Tooltip:Cancels out of opening the collection and closes this dialog, discarding any changes made in the dialog.
-FormatConversionDialog.GS2_Text_Tooltip:Greenstone2 format statement.
-FormatConversionDialog.GS3_Text_Tooltip:Greenstone3 format statement, must be XML to be active in Greenstone.
-FormatConversionDialog.Tidy_Failed:Tidy failed.
-FormatConversionDialog.Tidy_Done:Tidy done.
 FormatConversionDialog.XML_Still_Invalid:XML is still invalid.
-FormatConversionDialog.Error_GS3_Format:Error in Greenstone3 format statement.
-FormatConversionDialog.Invalid_XML:Invalid XML.
-FormatConversionDialog.Invalid_XML_Warning_Title:Cancel or Continue?
-FormatConversionDialog.Cancel_Or_Continue_Next:Either press Cancel to go back and re-edit the XML.\nOr press OK to store the current XML as-is, albeit inactive, and continue on to the next statement.\nYou can later use the Format tab to revisit this format statement if you want to update its syntax.
-FormatConversionDialog.Cancel_Or_Accept_All:One or more Greenstone3 format statements contains invalid XML.\nEither press Cancel to correct the XML.\nOr press OK to store the Greenstone3 format statements as-is, albeit inactive.\nYou can later use the Format tab to revisit the format statements if you want to update their syntax.
 
 #**********************
Index: main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29031)
+++ main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29034)
@@ -110,5 +110,5 @@
 	this.setComponentOrientation(Dictionary.getOrientation());
 	setSize(SIZE);
-	setTitle(Dictionary.get(Dictionary.get("FormatConversionDialog.Title")));
+	setTitle(Dictionary.get("FormatConversionDialog.Title"));
 	this.addWindowListener(new WindowClosingListener()); // the dialog's top right close button should behave as a Cancel press
 	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
@@ -393,6 +393,6 @@
 	if(!validationMsg.startsWith(XMLTools.WELLFORMED)) {
 	    // Run Html Tidy in XML mode
-	    System.err.println("*** Needing to run HTML Tidy on: ");
-	    System.err.println(gs3formatstr_notags);	    
+	    //System.err.println("*** Needing to run HTML Tidy on: ");
+	    //System.err.println(gs3formatstr_notags);	    
 
 
Index: main/trunk/gli/src/org/greenstone/gatherer/gui/NumberedJTextArea.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/gui/NumberedJTextArea.java	(revision 29031)
+++ main/trunk/gli/src/org/greenstone/gatherer/gui/NumberedJTextArea.java	(revision 29034)
@@ -93,5 +93,5 @@
 	setRows(11);
 	setWrapStyleWord(false);	
-	setToolTipText(Dictionary.get("FormatConversionDialog.GS2_Text_Tooltip"));
+	setToolTipText(tooltip);
     }
     