Index: local/greenstone2/windows-64bit/setup32.bat
===================================================================
--- local/greenstone2/windows-64bit/setup32.bat	(revision 29056)
+++ local/greenstone2/windows-64bit/setup32.bat	(revision 29059)
@@ -15,25 +15,23 @@
 echo + Set PERL_PATH=%PERL_HOME% and updated PATH
 
-:: WORKS:
-call "C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"
+:: Setup Visual Studio env
 
-:: Common Tools folder not found
-:: call "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\bin\vcvars32.bat"
+:: Running VS in 64 bit mode doesn't work, need to run in 32 bit mode.
+:: For now only VS9.0 (VS2008) works
+:: call "C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"
+set vslocation=C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\Tools
+if not exist "%vslocation%" echo %vslocation% does not exist& goto done
+pushd "%vslocation%"
+call vsvars32.bat
+popd
 
-:: Same problem as with C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64_x86\vcvarsamd64_x86.bat
-:: call "C:\Program Files (x86)\Microsoft Visual Studio 12.0\Common7\Tools\vsvars32.bat"
+:: VS10 fails: Common Tools folder not found for VS10
+rem call "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\bin\vcvars32.bat"
 
-
-:: 64 bit mode doesn't work
-:: Running vcvarsamd64_x86 has the same problem as below
-::set vclocation=C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC
-::set vclocation=C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC
-::::set vclocation=C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64_x86
-::if not exist "%vclocation%" echo %vclocation% does not exist& goto done
-::pushd "%vclocation%"
-::call vcvarsamd64_x86.bat
-::::call vcvarsall.bat amd64
-::popd
-
+:: VS12 fails: Calling "vsvars32.bat" above produces the same error as calling
+:: C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64_x86\vcvarsamd64_x86.bat
+:: (and possibly the same error as calling
+:: C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\vcvarsall.bat without passing "amd64" param)
+rem call "C:\Program Files (x86)\Microsoft Visual Studio 12.0\Common7\Tools\vsvars32.bat"
 
 :: Error: https://groups.google.com/forum/#!topic/UniMRCP/Iybpn51UYnI
@@ -41,13 +39,7 @@
 :: http://stackoverflow.com/questions/11544563/can-i-set-the-platform-toolset-from-the-command-line-when-building-with-vs2010s
 :: /p:PlatformToolset=v100
-:: call "C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64_x86\vcvarsamd64_x86.bat"
 
 
-:: If using SetEnv.cmd:
-
-:: http://go4answers.webhost4life.com/Example/windows-sdk-v70a-setenvbat-218785.aspx
-:: explains that SetEnv.cmd does exist in the new Microsoft SDK:
-:: C:\Windows\System32\cmd.exe /E:ON /V:ON /T:0E /K "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd"
-:: (Unused: http://stackoverflow.com/questions/887894/how-to-find-windows-sdks-setenv-cmd-setenv-cmd-does-not-work-correctly )
+:: If using SetEnv.cmd to set up MS SDK env (no longer needed even for compiling GS2 with debug):
 
 ::call "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd"
@@ -60,12 +52,5 @@
 ::popd
 
-:: http://www.apachelounge.com/viewtopic.php?t=3348
-:: http://stackoverflow.com/questions/10888391/error-link-fatal-error-lnk1123-failure-during-conversion-to-coff-file-inval
-:: https://ask.mozilla.org/question/256/failure-during-conversion-to-coff-file-invalid-or-corrupt/
-:: Rename cvtres.exe in C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\bin\amd64, then put the one from
-:: C:\Windows\Microsoft.NET\Framework\v4.0.30319 (or from C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64) in there
-::set cvlocation=C:\Windows\Microsoft.NET\Framework\v4.0.30319
-::set cvlocation=C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64
-::if exist "%cvlocation%\cvtres.exe" set PATH=%cvlocation%;%PATH%
+
 
 :done
@@ -74,3 +59,2 @@
 echo.
 
-:: http://stackoverflow.com/questions/10888391/error-link-fatal-error-lnk1123-failure-during-conversion-to-coff-file-inval